<template>
  <Head title="Menu" />

  <Layout>
    <div class="max-w-full mx-auto sm:px-2 lg:px-2">
      <div class="lg:flex lg:items-center lg:justify-between py-4">
        <div class="flex-1 min-w-0">
          <!-- {/* Title Page */} -->
          <h2
            class="
              text-2xl
              font-semibold
              text-gray-700
              dark:text-gray-200
              sm:text-3xl sm:truncate
            "
          >
            Menu
          </h2>
          <!-- {/* Breadcumb */} -->
          <div
            class="
              mt-1
              flex flex-col
              sm:flex-row sm:flex-wrap sm:mt-0 sm:space-x-6
            "
          >
            <ul class="flex text-gray-900 text-sm lg:text-base">
              <li class="inline-flex items-center">
                <Link :href="route('dashboard')">Dashboard</Link>
                <Icon
                  :name="`chevron-right`"
                  :style="`h-5 w-auto text-gray-400`"
                />
              </li>
              <li class="inline-flex items-center">
                <Link :href="route('menu')" class="text-gray-500"> Menu </Link>
                <Icon
                  :name="`chevron-right`"
                  :style="`h-5 w-auto text-gray-400`"
                />
              </li>
              <li class="inline-flex items-center">
                <Link href="#" class="text-gray-500"> Edit </Link>
              </li>
            </ul>
          </div>
        </div>
        <div class="mt-5 flex lg:mt-0 lg:ml-4"></div>
      </div>

      <div class="w-full overflow-hidden rounded-lg shadow-xs">
        <div class="w-full overflow-x-auto">
          <div class="mt-5 md:mt-0 md:col-span-2">
            <form @submit.prevent="update">
              <div class="shadow sm:rounded-xl sm:overflow-hidden">
                <div class="px-4 py-5 bg-white space-y-6 sm:p-6">
                  <div class="grid grid-cols-1 gap-6">
                    <div class="col-span-3 sm:col-span-2">
                      <Label for="name" value="Name" />
                      <Input
                        id="name"
                        type="text"
                        :class="
                          form.errors.name
                            ? 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 mt-2 block w-full focus:ring-red-500 focus:border-red-500 border-red-600'
                            : 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 mt-2 block w-full'
                        "
                        v-model="form.name"
                      />
                      <div
                        v-if="form.errors.name"
                        className="py-1 text-red-600 text-sm font-medium"
                      >
                        {{ form.errors.name }}
                      </div>
                    </div>
                  </div>

                  <div class="grid grid-cols-1 gap-6">
                    <div class="col-span-3 sm:col-span-2">
                      <Label for="qty" value="Qty" />
                      <Input
                        id="qty"
                        type="number"
                        @keypress="NumbersOnly($event)"
                        min="1"
                        :class="
                          form.errors.qty
                            ? 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 mt-2 block w-full focus:ring-red-500 focus:border-red-500 border-red-600'
                            : 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 mt-2 block w-full'
                        "
                        v-model="form.qty"
                      />
                      <div
                        v-if="form.errors.qty"
                        className="py-1 text-red-600 text-sm font-medium"
                      >
                        {{ form.errors.qty }}
                      </div>
                    </div>
                  </div>

                  <div class="grid grid-cols-1 gap-6">
                    <div class="col-span-3 sm:col-span-2">
                      <Label for="price" value="Price" />
                      <Input
                        id="price"
                        type="text"
                        @keypress="NumbersOnly($event)"
                        :class="
                          form.errors.price
                            ? 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 mt-2 block w-full focus:ring-red-500 focus:border-red-500 border-red-600'
                            : 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 mt-2 block w-full'
                        "
                        v-model="form.price"
                      />
                      <div
                        v-if="form.errors.price"
                        className="py-1 text-red-600 text-sm font-medium"
                      >
                        {{ form.errors.price }}
                      </div>
                    </div>
                  </div>

                  <div class="grid grid-cols-1 gap-6">
                    <div class="col-span-3 sm:col-span-2">
                      <Label for="description" value="Description" />
                      <Input
                        id="description"
                        type="text"
                        :class="
                          form.errors.description
                            ? 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 mt-2 block w-full focus:ring-red-500 focus:border-red-500 border-red-600'
                            : 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 mt-2 block w-full'
                        "
                        v-model="form.description"
                      />
                      <div
                        v-if="form.errors.description"
                        className="py-1 text-red-600 text-sm font-medium"
                      >
                        {{ form.errors.description }}
                      </div>
                    </div>
                  </div>

                  <div class="grid grid-cols-1 gap-6">
                    <div class="col-span-3 sm:col-span-2">
                      <Label for="description" value="Category" />
                      <Multiselect
                        v-model="form.category"
                        :options="categories"
                        :close-on-select="true"
                        :searchable="false"
                        placeholder="-- Choose Category --"
                        label="name"
                        track-by="id"
                      ></Multiselect>
                      <div
                        v-if="form.errors.category"
                        className="py-1 text-red-600 text-sm font-medium"
                      >
                        {{ form.errors.category }}
                      </div>
                    </div>
                  </div>

                  <div class="grid grid-cols-1 gap-6">
                    <Label for="cover" value="cover" />
                    <div class="px-1">
                      <input
                        type="file"
                        :class="
                          form.errors.cover
                            ? 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full focus:ring-red-500 focus:border-red-500 border-red-600'
                            : 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full'
                        "
                        @change="updatePhotoPreview"
                        @input="form.cover = $event.target.files[0]"
                      />
                      <div
                        v-if="form.errors.cover"
                        className="py-1 text-red-600 text-sm font-medium"
                      >
                        {{ form.errors.cover }}
                      </div>
                    </div>
                  </div>

                  <div class="grid grid-cols-4 image">
                    <div
                      :class="{
                        'h-auto w-full mx-auto bg-clip-border border-4 border-red-300 border-dashed':
                          form.previewPhoto,
                      }"
                    >
                      <img :src="form.previewPhoto" />
                    </div>
                  </div>

                  <div class="px-4 py-3 flex justify-end">
                    <Link
                      :href="route('menu')"
                      class="
                        inline-flex
                        items-center
                        px-4
                        py-2
                        bg-gray-600
                        hover:bg-gray-700
                        border border-transparent
                        rounded-md
                        font-semibold
                        text-xs text-white
                        uppercase
                        tracking-widest
                      "
                    >
                      <Icon :name="`backspace`" :style="`-ml-1 mr-2 h-5 w-5`" />
                      Cancel
                    </Link>

                    <Button
                      v-if="$page.props.auth.can.update_category"
                      class="ml-4"
                      :class="{ 'opacity-25': form.processing }"
                      :disabled="form.processing"
                    >
                      <Icon :name="`save`" :style="`-ml-1 mr-2 h-5 w-5`" />
                      Submit
                    </Button>
                  </div>
                </div>
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>
  </Layout>
</template>

<script>
import Layout from "@/Layouts/App.vue";
import { Head } from "@inertiajs/inertia-vue3";
import { Link } from "@inertiajs/inertia-vue3";
import Icon from "@/Components/Icon";
import Input from "@/Components/Input.vue";
import Label from "@/Components/Label.vue";
import Button from "@/Components/Button.vue";
import Multiselect from "@suadelabs/vue3-multiselect";

export default {
  components: {
    Layout,
    Head,
    Link,
    Icon,
    Button,
    Input,
    Label,
    Multiselect,
  },
  props: {
    categories: {
      type: Array,
    },    
    menu: Object,
  },
  data() {
    return {
      form: this.$inertia.form({
        name: this.menu.name || null,
        category: this.categories.find(option => option.id === this.menu.category_id),
        description: this.menu.description || null,
        qty: this.menu.qty || null,
        price: this.menu.price || null,
        cover: null,
        previewPhoto: this.menu.cover
          ? "/storage/images/" + this.menu.cover
          : "/images/image-not-found.png",
      }),
    };
  },
  // mounted() {
  //   this.form.category_id = this.categories.find(option => option.id === this.menu.category_id);
  // },
  methods: {
    update() {
      // console.log(this.form.name)
      this.form.put(this.route("menu.update", this.menu.id));
    },
    updatePhotoPreview(e) {
      // console.log(e.target.files[0]);
      this.form.previewPhoto = URL.createObjectURL(e.target.files[0]);
    },
    NumbersOnly(evt) {
      evt = evt ? evt : window.event;
      var charCode = evt.which ? evt.which : evt.keyCode;
      if (
        charCode > 31 &&
        (charCode < 48 || charCode > 57) &&
        charCode !== 46
      ) {
        evt.preventDefault();
      } else {
        return true;
      }
    },
  },
};
</script>
